//TESH.scrollpos=158
//TESH.alwaysfold=0
<?import("init.lua")[[
require "jass.console".enable = true
]]?>

<?import("main.lua")[=[


local message = require "jass.message"
local jass = require "jass.common"
local slk = require "jass.slk"
local runtime = require "jass.runtime"
local japi = require "jass.japi"
local keyboard = message.keyboard

--
-- Test code showing locally issued commands
-- Must not be used in a formal environment
--
message.order_enable_debug()


-- target allowed FLAG
local FLAG = {
    ["ground"]        = 1 << 1,
    ["aerial"]        = 1 << 2,
    ["architecture"]        = 1 << 3,
    ["guard"]        = 1 << 4,
    ["thing"]        = 1 << 5,
    ["trees"]        = 1 << 6,
    ["wall"]          = 1 << 7,
    ["wreckage"]        = 1 << 8,
    ["decorations"]      = 1 << 9,
    ["bridge"]          = 1 << 10,
    ["Location"]        = 1 << 11,
    ["Own"]        = 1 << 12,
    ["player unit"]    = 1 << 13,
    ["alliance"]        = 1 << 14,
    ["neutral"]        = 1 << 15,
    ["enemy"]        = 1 << 16,
    ["unknown"]        = 1 << 17,
    ["unknown"]        = 1 << 18,
    ["unknown"]        = 1 << 19,
    ["attackable"]    = 1 << 20,
    ["Invunerable"]        = 1 << 21,
    ["hero"]        = 1 << 22,
    ["non-hero"]     = 1 << 23,
    ["survive"]        = 1 << 24,
    ["die"]        = 1 << 25,
    ["organic organisms"]    = 1 << 26,
    ["mechanical"]      = 1 << 27,
    ["non-explosive sapper"] = 1 << 28,
    ["self-destruction sappers"]    = 1 << 29,
    ["non-ancient tree"]     = 1 << 30,
    ["ancient tree"]        = 1 << 31,
}

FLAG["Enemy and self judgment"] = FLAG["Own"] | FLAG["player unit"] | FLAG["alliance"] | FLAG["neutral"] | FLAG["enemy"]

-- Determines whether a unit meets the skill's objective allowable
local function target_filter(unit, flag, slk)
    local player = jass.GetOwningPlayer(message.selection())
    -- visible
    if jass.IsUnitInvisible(unit, player) then
        return false
    end
    -- survive
    if flag & FLAG["die"] == 0 and jass.IsUnitType(unit, jass.UNIT_TYPE_DEAD) then
        return false
    end
    -- Invunerable
    if flag & FLAG["Invunerable"] == 0 and jass.GetUnitAbilityLevel(unit, 1098282348 --[['Avul']]) == 1 then
        return false
    end
    -- Magic Immunity
    if (not tonumber(slk.reqLevel) or tonumber(slk.reqLevel) <= 1) and jass.IsUnitType(unit, jass.UNIT_TYPE_MAGIC_IMMUNE) then
        return false
    end
    if flag & FLAG["Enemy and self judgment"] ~= 0 then
        -- enemy
        if flag & FLAG["enemy"] == 0 and jass.IsUnitEnemy(unit, player) then
            return false
        end
        -- Own
        if flag & FLAG["Own"] == 0 and unit == message.selection() then
            return false
        end
        -- player unit
        if flag & FLAG["player unit"] == 0 and jass.GetOwningPlayer(unit) == player then
            return false
        end
        -- alliance
        if flag & FLAG["alliance"] == 0 and jass.IsUnitAlly(unit, player) then
            return false
        end
    end
    -- non hero
    if flag & FLAG["non-hero"] ~= 0 and jass.IsHeroUnitId(unit) then
        return false
    end
    -- hero
    if flag & FLAG["hero"] ~= 0 and not jass.IsHeroUnitId(unit) then
        return false
    end
    -- More filters, please define yourself
    return true
end

-- Find a unit from the mouse position
local jass_group = jass.CreateGroup()
local function find_target(ability, x, y)
    -- Read the target type of the skill
    local data = slk.ability[ability]
    if not data then
        return nil
    end
    local level = jass.GetUnitAbilityLevel(message.selection(), ability)
    -- Take out the target type of the skill
    local target_type = japi.EXGetAbilityDataInteger(japi.EXGetUnitAbility(message.selection(), ability), level, 0x64)
    local group = {}
    -- Select unit group
    jass.GroupEnumUnitsInRange(jass_group, x, y, 200, nil)
    while true do
        local unit = jass.FirstOfGroup(jass_group)
        if not unit then 
            break
        end
        -- Determine whether the target is allowed
        if target_filter(unit, target_type, data) then
            table.insert(group, unit)
        end
        jass.GroupRemoveUnit(jass_group, unit)
    end
    -- Sort to find the closest unit
    table.sort(group, function(u1, u2)
        -- Heroes take precedence over non-heroes
        local h1 = jass.IsHeroUnitId(u1)
        local h2 = jass.IsHeroUnitId(u2)
        if h1 and not h2 then
            -- return true Express u1 Ranked u2 Front
            return true
        end
        if h2 and not h1 then
            -- return false Express u2 Ranked u1 Front
            return false
        end
        -- The closer the distance the better
        local x1 = jass.GetUnitX(u1)
        local y1 = jass.GetUnitY(u1)
        local x2 = jass.GetUnitX(u2)
        local y2 = jass.GetUnitY(u2)
        return (x1 - x) * (x1 - x) + (y1 - y) * (y1 - y) < (x2 - x) * (x2 - x) + (y2 - y) * (y2 - y)
    end)
    -- Returns the first unit in the unit group
    return group[1]
end


-- local news FLAG
local FLAG = {
    ["queue"] = 1 << 0,    -- The command enters the queue, which is equivalent to pressing and holding shift issue instructions
    ["Instant"] = 1 << 1,    -- An instant command, which immediately triggers the issue command event (even if the unit is stunned)
    ["Independence"] = 1 << 2,    -- Cast alone, only one unit will respond to the command when multiple units are selected
    ["recover"] = 1 << 5,    -- Resume command, the previous command will be restored after the command is completed
}

-- Activate the skill immediately
local function cast_ability(ability, order, target_type)
    -- where the mouse is currently pointing
    local x, y = message.mouse()
    if target_type == 2 then
        -- point target command
        message.order_point(order, x, y, FLAG["Independence"] | FLAG["recover"])
        -- return false Express,This message will be thrown away(war3 will not receive)
        return false
    elseif target_type == 4 then
        -- unit target command
        -- Find skill targets
        local target = find_target(ability, x, y)
        if target then
            message.order_target(order, x, y, target, FLAG["Independence"] | FLAG["recover"])
        end
        return false
    elseif target_type == 1 then
        -- no target command
        message.order_immediate(order, FLAG["Independence"] | FLAG["recover"])
        return false
    end
    return true
end

--
-- Keyboard message callback function
-- mostly jass function cannot be used in this function
-- If needed use jass function, you can save the keyboard message and process this message in the timer
--
function message.hook(msg)
    if not message.selection() then
        return true
    end
    if msg.type == 'key_down' then
        -- Traverse the skill bar to find the skill you want to press
        for x = 0, 3 do
            for y = 0, 2 do
                -- message.button,Find skills by gridid,Order id,target type
                local ability, order, target_type = message.button(x, y)
                local ability_data = slk.ability[ability]
                if ability_data then
           